/***
 * Excerpted from "Modern Asynchronous JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit https://pragprog.com/titles/fkajs for more book information.
***/
const collection = {
  a: 10,
  b: 20,
  c: 30,
  [Symbol.asyncIterator]() {
    const keys = Object.keys(this);
    let i = 0;
    return {
      next: () => {
        return new Promise((resolve, reject) => {   
          setTimeout(() => {
            resolve({
              value: this[keys[i++]],
              done: i > keys.length
            });
          }, 1000);
        });
      }
    };
  }
};

const iterator = collection[Symbol.asyncIterator]();

iterator.next().then(result => {
  console.log(result);  // ⇒ {value: 10, done: false}
});

iterator.next().then(result => {
  console.log(result);  // ⇒ {value: 20, done: false} 
});

iterator.next().then(result => {
  console.log(result);  // ⇒ {value: 30, done: false} 
});

iterator.next().then(result => {
  console.log(result);  // ⇒ {value: undefined, done: true} 
});